# coding: utf-8
u'''
Основной грид реестра циклов по курсам.

'''

from java.text import SimpleDateFormat
import json
from java.sql import Timestamp

from common.sysfunctions import toHexForXml, getGridHeight
from edu._edu_orm import vw_program_cycleCursor, course_edu_formCursor, course_edu_baseCursor
from nci._nci_orm import education_baseCursor, edu_organizationCursor,\
    education_formCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from security.functions import userHasPermission
from com.jayway.jsonpath import JsonPath
from nci.functions.persons import getPersonIdBySid

from gridsettings.functions.gridSettings import toolbar_button_default,toolbar_button, get_column_meta,\
                                                filter_button, get_column_header, get_column_data, filter_reset_button
from gridsettings._gridsettings_orm import grid_fieldCursor, user_grid_fieldCursor
try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO
    
COURSE_STATUS = {
    20: u'Прохожу программу',
    2: u"Заявка подана",
    7: u"Заявка отклонена",
    21: u'Обучение завершено',
    22: u'Отчислен'
    }


def gridData(context, main, add=None, filterinfo=None, session=None, elementId=None,
             sortColumnList=None, firstrecord=None, pagesize=None):
    session = json.loads(session)['sessioncontext']
    sid = session['sid']
    programCycle = vw_program_cycleCursor(context)
    course_edu_base = course_edu_baseCursor(context)
    course_edu_form = course_edu_formCursor(context)
    edu_form = education_formCursor(context)
    education_base = education_baseCursor(context)
    grid_field = grid_fieldCursor(context)
    user_grid_field = user_grid_fieldCursor(context)
    # Заголовки
    _header = {'uid': ['~~id','id'],
               'properties': [u'properties', 'properties']}        
    _header.update(get_column_header(grid_field,user_grid_field,elementId,sid))        
    for column in _header:
        _header[column].append(toHexForXml(_header[column][0]))   

    programCycle.setRange('status_id',3)#Только утверждённые циклы
    programCycle.limit(firstrecord - 1, pagesize) 

    if context.getData().get('dpppkFilter',''):
        ext_filter(context.getData()['dpppkFilter'],programCycle,context)    
    
    person_id = getPersonIdBySid(context, sid)
    grid_data = {'records': {'rec': []}}
    
    
    student_program = vw_student_programCursor(context)
    student_program.setRange('person_id', person_id)
    student_program.setFilter('status_id', '<21')
    
    for program in programCycle.iterate():
        cource_id = program.uuid
        courseStatus = ''
        student_program.setRange('course_id', cource_id)
        if student_program.tryFirst():
            courseStatus =  COURSE_STATUS[student_program.status_id]
               
        row = {}
        row[_header['uid'][2]] = cource_id
        course_edu_base.setRange('course_id', cource_id)
        edu_base_names = []
        for course_edu_base in course_edu_base.iterate():
            education_base.get(course_edu_base.edu_base_id)
            edu_base_names.append(education_base.name)
            
        u"""Название формы обучения"""
        edu_form_name = ""
        
        u"""Получение названия формы обучения"""
        course_edu_form.setRange("course_id",cource_id)
        for form in course_edu_form.iterate():
            edu_form.get(form.edu_form_id)
            edu_form_name += edu_form.name + ", "
        edu_form_name = edu_form_name[:-2]#отсечение последней запятой и пробела
            
        add_data = {
                    'info':{'div':{'ins':{'font':{"@style": "cursor: pointer",
                                                  '@color':'blue',
                                                  "@title": u"Подать заявку",
                                                 '#text':u'Подать заявку'}}}} if not courseStatus else courseStatus,
                    'name':{'div':{'ins':{'font':{"@style": "cursor: pointer",
                                                  '@color':'blue',
                                                  "@title": program.name,
                                                 '#text': program.name}}}},
                    'edu_base':','.join(edu_base_names),
                    "education_form_name": edu_form_name,
                    "start_date": '',
                    "end_date": '',
                    'edu_org_shortname':{'div':{'ins':{'font':{"@style": "cursor: pointer",
                                          '@color':'blue',
                                          "@title": u"Просмотреть подробную информацию об образовательной организации",
                                         '#text':program.edu_org_shortname}}}},
                    'program_link':{'div':{'a':{'@href':program.program_link,
                                                '#text':program.program_link}}}}
        get_column_data(_header, grid_field, user_grid_field, elementId, sid, program, row, **add_data)

        row[_header['properties'][2]] =  {'event': []}
        if ('info' in _header) and (not courseStatus):
            row[_header['properties'][2]]['event'].append( {
                            '@name': 'cell_single_click',
                            '@column': _header['info'][0],
                            'action': {
                                '@show_in': 'MODAL_WINDOW',
                                '#sorted': [
                                    {'main_context': 'current'},
                                    {'modalwindow': {
                                        '@caption': u'Подача заявки',
                                        '@height': '570',
                                        '@width': '660'}},
                                    {'datapanel': {
                                        '@type': 'current',
                                        '@tab': 'current',
                                        'element': {
                                            '@id': 'downloadCertificateCard',
                                            'add_context': 'download'}}}]}}) 

        if 'name' in _header:
            row[_header['properties'][2]]['event'].append( {
                            '@name': 'cell_single_click',
                            '@column': _header['name'][0],
                            'action': {
                                '@show_in': 'MODAL_WINDOW',
                                '#sorted': [
                                    {'main_context': 'current'},
                                    {'modalwindow': {
                                        '@caption': u'Сведения о программе',
                                        '@height': '570',
                                        '@width': '660'}},
                                        {'datapanel': {
                                            '@type': 'current',
                                            '@tab': 'current',
                                            'element': {
                                                '@id': 'courseCard',
                                                'add_context': 'infoCard'}}}]}})                 
        if 'edu_org_shortname' in _header:
                    row[_header['properties'][2]]['event'].append( {
                                    '@name': 'cell_single_click',
                                    '@column': _header['edu_org_shortname'][0],
                                    'action': {
                                        '@show_in': 'MODAL_WINDOW',
                                        '#sorted': [
                                            {'main_context': 'current'},
                                            {'modalwindow': {
                                                '@caption': u'Информация об образовательной организации',
                                                '@height': '700',
                                                '@width': '660'}},
                                            {'datapanel': {
                                                '@type': 'current',
                                                '@tab': 'current',
                                                'element': {
                                                    '@id': 'eduOrgInfoCard'}}}]}})                       
        
        grid_data['records']['rec'].append(row)

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(grid_data)),
                     None)


def gridMeta(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    sid = JsonPath.read(session, "$.sessioncontext.sid")
    session = json.loads(session)
    programCycle = vw_program_cycleCursor(context)


    filter_string = ''
    if context.getData().get('dpppkFilter',''):
        filter_string = ext_filter(context.getData()['dpppkFilter'],programCycle,context)
    programCycle.setRange('status_id',3)#Только утверждённые циклы
    grid_settings = {}
    grid_settings['gridsettings'] = {
        'labels': {
            'header': u'Программы <br>' + filter_string
        },
        'columns': {
            'col': get_column_meta(context,elementId,sid)
        },
        'properties': {
            '@pagesize': 50,
            '@gridWidth': '100%',
            '@gridHeight': getGridHeight(session, numberOfGrids=1, gridHeaderHeight=55, delta=59),
            '@totalCount': programCycle.count(),
            '@profile': 'default.properties'
        },
    }


    return JythonDTO(None,
                     XMLJSONConverter.jsonToXml(json.dumps(grid_settings)))


def gridToolBar(context, main=None, add=None, filterinfo=None, session=None, elementId=None):

    session_json = json.loads(session)['sessioncontext']
    sid = session_json['sid']
    grid_context = session_json['related']['gridContext']
    
    if "currentRecordId" in grid_context:
        downloadStyle = "false"
    else:
        downloadStyle = "true"

    grid_toolbar = {
        'gridtoolbar': {
            '#sorted': [
                toolbar_button(context, sid, elementId),
                toolbar_button_default(context, sid, elementId),
                filter_button('dpppkFilter',800,700),
                filter_reset_button(elementId, 'dpppkFilter'),
#                 {'item': {
#                     '@text': u'Подать заявку',
#                     '@hint': u'Подать заявку',
#                     '@disable': downloadStyle,
#                     'action': {
#                         '@show_in': 'MODAL_WINDOW',
#                         '#sorted': [
#                             {'main_context': 'current'},
#                             {'modalwindow': {
#                                 '@caption': u'Подача заявки',
#                                 '@height': '600',
#                                 '@width': '700'}},
#                             {'datapanel': {
#                                 '@type': 'current',
#                                 '@tab': 'current',
#                                 'element': {
#                                     '@id': 'downloadCertificateCard',
#                                     'add_context': 'download'}}}]}}}
                ]}}

    return XMLJSONConverter.jsonToXml(json.dumps(grid_toolbar))


def ext_filter(session,program_cycle,context):
    filter_string = u"Фильтр: "
    edu_organization = edu_organizationCursor(context)
    sdf = SimpleDateFormat('dd.MM.yyyy')
    filter_list = []
    whereclause = '1 = 1'
    def str2bool(str):
        if str == 'false':
            return False
        elif str == 'true':
            return True
        else:
            return False
    if True:
        data = session['schema']['record']
        name = data['name']
        fromDate = data['dateFrom']
        toDate = data['dateTo']
        speciality_id = data['speciality_id']
        speciality_name = data['speciality_name']
        edu_org_id = data['edu_organization_id']
        dot_eo = data['dot_eo']
        certification = data['certificate']
        simulation = data['simulation']
        intern = data['intern']
        hours_from = data['hours_from']
        hours_to = data['hours_to']
        cost_from = data['cost_from']
        cost_to = data['cost_to']
        hours_sim_from = data['hours_sim_from']
        hours_sim_to = data['hours_sim_to']
        hours_intern_from = data['hours_intern_from']
        hours_intern_to = data['hours_intern_to']
        edu_form_id = data['edu_form_id']
        edu_form_name = data['edu_form_name']
#         certificate = data['certificate']
        simulation = data['simulation']
        intern = data['intern']
        program_cycle.setFilter('name',"@%%'%s'%%"%(name))
        if name:
            filter_list.append(u'название содержит %s'%(name))
        if fromDate != '':
            fromDate = Timestamp.valueOf(u'%s 00:00:00.0' % fromDate)
        if toDate != '':
            toDate = Timestamp.valueOf(u'%s 23:59:59.0' % toDate)
        if fromDate != '' and toDate != '':
            filter_list.append(u'дата начала с %s по %s'%(sdf.format(fromDate),sdf.format(toDate)))
            program_cycle.setRange('start_date',fromDate,toDate)
        elif fromDate != '' and toDate == '':
            filter_list.append(u'дата начала с %s'%(sdf.format(fromDate)))
            whereclause += " and start_date >= '%s'"%(fromDate)
#             vw_schedulelesson.setFilter('timeStart','"20131124"')
#             vw_schedulelesson.setFilter('timeStart',"('%s'..)" % (fromDate))
        elif fromDate == '' and toDate != '':
            filter_list.append(u'дата начала  по %s'%(sdf.format(toDate)))
            whereclause += " and start_date <= '%s'"%(toDate)
        if speciality_id:
            filter_list.append(u'специальность %s'%(speciality_name))
            program_cycle.setRange('speciality_id',speciality_id)
        if edu_org_id:
            edu_organization.get(edu_org_id)
            filter_list.append(u'образовательная организация: %s'%(edu_organization.abbreviation))
            program_cycle.setRange('edu_organization_id',edu_org_id)
        if dot_eo != '-':
            filter_list.append(u"ДОТ и ЭО: %s"%(u'Да' if str2bool(dot_and_eo) else u'Нет'))
            program_cycle.setRange('dot_eo',str2bool(dot_eo))
        if simulation != '-':
            filter_list.append(u"cимуляционное обучение: %s"%(u'Да' if str2bool(simulation) else u'Нет'))
            program_cycle.setRange('osk',str2bool(simulation))
        if intern != '-':
            filter_list.append(u"cтажировка: %s"%(u'Да' if str2bool(intern) else u'Нет'))
            program_cycle.setRange('internship',str2bool(intern))
        if certification != '-':
            filter_list.append(u"сертификационный: %s"%(u'Да' if str2bool(certification) else u'Нет'))
            program_cycle.setRange('is_certification',str2bool(certification))
        if hours_from and hours_to:
            filter_list.append(u"трудоёмкость,ЗЕТ от %s до %s"%(hours_from,hours_to))
            program_cycle.setRange('hours',float(hours_from), float(hours_to))
        elif hours_from:
            filter_list.append(u"трудоёмкость,ЗЕТ от %s"%(hours_from))
            program_cycle.setFilter('hours', '%s..' % hours_from)
        elif hours_to:
            filter_list.append(u"трудоёмкость,ЗЕТ до %s"%(hours_to))
            program_cycle.setFilter('hours', '..%s' % hours_to)
        if cost_from and cost_to:
            filter_list.append(u"стоимость от %s до %s"%(cost_from,cost_to))
            program_cycle.setRange('price',float(cost_from), float(cost_to))
        elif cost_from:
            filter_list.append(u"стоимость от %s"%(cost_from))
            program_cycle.setFilter('price', '%s..' % cost_from)
        elif cost_to:
            filter_list.append(u"стоимость до %s"%(cost_to))
            program_cycle.setFilter('price', '..%s' % cost_to)
        if hours_sim_from and hours_sim_to:
            filter_list.append(u"объём симуляционного обучения от %s до %s ЗЕТ"%(hours_sim_from,hours_sim_to))
            program_cycle.setRange('osk_hours',float(hours_sim_from), float(hours_sim_to))
        elif hours_sim_from:
            filter_list.append(u"объём симуляционного обучения от %s ЗЕТ"%(hours_sim_from))
            program_cycle.setFilter('osk_hours', '%s..' % hours_sim_from)
        elif hours_sim_to:
            filter_list.append(u"объём симуляционного обучения до %s ЗЕТ"%(hours_sim_to))
            program_cycle.setFilter('osk_hours', '..%s' % hours_sim_to)
        if hours_intern_from and hours_intern_to:
            filter_list.append(u"объём стажировки от %s ЗЕТ до %s ЗЕТ"%(hours_intern_from,hours_intern_to))
            program_cycle.setRange('internship_hours',float(hours_intern_from), float(hours_intern_to))
        elif hours_intern_from:
            filter_list.append(u"объём стажировки от %s ЗЕТ"%(hours_intern_from))
            program_cycle.setFilter('internship_hours', '%s..' % hours_intern_from)
        elif hours_intern_to:
            filter_list.append(u"объём стажировки до %s ЗЕТ"%(hours_intern_to))
            program_cycle.setFilter('internship_hours', '..%s' % hours_intern_to)
        if edu_form_id:
            filter_list.append(u'форма обучения: %s'%(edu_form_name))
            program_cycle.setRange('education_form_id',edu_form_id)
    program_cycle.setComplexFilter(whereclause)
    filter_string = '<b style="font-family:courier new">' + filter_string + ', '.join(filter_list) +'</b>'
    return filter_string
from medstaff._medstaff_orm import student_programCursor,\
    vw_student_programCursor
