# coding: utf-8
u'''
Основной грид реестра циклов по курсам.

'''

# from java.text import SimpleDateFormat
import json
# from java.sql import Timestamp
from medstaff._medstaff_orm import vw_student_cycleCursor, student_cycleCursor
from common.sysfunctions import toHexForXml, getGridHeight
from edu._edu_orm import cycle_edu_baseCursor
from nci._nci_orm import education_baseCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
# from security.functions import userHasPermission
from com.jayway.jsonpath import JsonPath
from nci.functions.persons import getPersonIdBySid

from gridsettings.functions.gridSettings import toolbar_button_default,toolbar_button, get_column_meta,\
    get_column_data, get_column_header
from gridsettings._gridsettings_orm import grid_fieldCursor, user_grid_fieldCursor
try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO


def gridData(context, main, add=None, filterinfo=None, session=None, elementId=None,
             sortColumnList=None, firstrecord=None, pagesize=None):
    session = json.loads(session)['sessioncontext']
    sid = session['sid']
    vw_student_cycle = vw_student_cycleCursor(context)

    grid_field = grid_fieldCursor(context)
    user_grid_field = user_grid_fieldCursor(context)
    # Заголовки
    _header = {'uid': ['~~id','id'],
               'properties': [u'properties', 'properties']}
    
    _header.update(get_column_header(grid_field,user_grid_field,elementId,sid))

    person_id = getPersonIdBySid(context, sid)
    
    main_jsn = json.loads(main)
#     courseId = main_jsn['courseId']
    certificate = main_jsn['certificate']

    vw_student_cycle.setRange('person_id',person_id)
    vw_student_cycle.setRange('certificate',certificate)
    vw_student_cycle.orderBy('cycle_order')
    vw_student_cycle.limit(firstrecord - 1, pagesize)

    grid_data = {'records': {'rec': []}}
    
    for column in _header:
        _header[column].append(toHexForXml(_header[column][0]))    

    for student_cycle in vw_student_cycle.iterate():
        row = {}
        row[_header['uid'][2]] = student_cycle.cycle_id

        get_column_data(_header, grid_field, user_grid_field, elementId, sid, student_cycle, row)

#         if 'dot_eo' in _header:
#             row[_header['dot_eo'][2]] += u':С применением дистанционных образовательных технологий и электронного обучения'
#         row[_header['properties'][2]] =  {'event': []}
        
        grid_data['records']['rec'].append(row)

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(grid_data)), None)


def gridMeta(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    sid = JsonPath.read(session, "$.sessioncontext.sid")
    person_id = getPersonIdBySid(context, sid)
    session = json.loads(session)
    
    main_jsn = json.loads(main)
#     courseId = main_jsn['courseId']
    certificate = main_jsn['certificate']
    
    student_cycle = student_cycleCursor(context)
    student_cycle.setRange('person_id',person_id)
    student_cycle.setRange('student_certificate',certificate)

    grid_settings = {}
    grid_settings['gridsettings'] = {
#         'labels': {
#             'header': 'Мои циклы '},
        'columns': {
            'col': get_column_meta(context,elementId,sid)},
        'properties': {
            '@pagesize': 50,
            '@gridWidth': '100%',
            '@gridHeight': getGridHeight(session, numberOfGrids=1, gridHeaderHeight=55),
            '@totalCount': student_cycle.count(),
            '@fireGeneralAndConcreteEvents':'true',
            '@profile': 'default.properties'}}
        
    return JythonDTO(None, XMLJSONConverter.jsonToXml(json.dumps(grid_settings)))


def gridToolBar(context, main=None, add=None, filterinfo=None, session=None, elementId=None):

    session_json = json.loads(session)['sessioncontext']
    sid = session_json['sid']
    grid_context = session_json['related']['gridContext']

#     if 'currentRecordId' in grid_context:
#         disable = 'false'
#         currRec = grid_context["currentRecordId"]
#     else:
#         disable = 'true'
#         currRec = ''

    grid_toolbar = {
        'gridtoolbar': {
            '#sorted': [
                toolbar_button(context, sid, elementId),
                toolbar_button_default(context, sid, elementId),
#                 filter_button('dpppkFilter',800,700),
#                 filter_reset_button(elementId, 'dpppkFilter'),
#                 {'item': {
#                     '@text': u'Перейти к циклу',
#                     '@hint': u'Перейти к циклу',
#                     '@disable': disable,
#                     'action': {
#                         '@show_in': 'MODAL_WINDOW',
#                         '#sorted': [
#                             {'main_context': 'current'},
#                             {'navigator': {
#                                 '@element': 'cycle-{}'.format(currRec),
#                                 '@refresh': 'true'}}]}}}
                        ]}}

    return XMLJSONConverter.jsonToXml(json.dumps(grid_toolbar))
