# coding: utf-8
'''
Created on 21.10.2016

@author: d.gulyakin
'''

import json
from security.functions import userHasPermission
from nci.functions.persons import getPersonIdBySid
from java.text import SimpleDateFormat
try:
    from ru.curs.showcase.core.jython import JythonDTO, JythonDownloadResult, JythonErrorResult
except:
    from ru.curs.celesta.showcase import JythonDTO, JythonDownloadResult, JythonErrorResult
    
from ru.curs.celesta.showcase.utils import XMLJSONConverter

from common.sysfunctions import toHexForXml, getGridHeight

from edu._edu_orm import vw_course_cycle_lecturesCursor


def gridData(context, main=None, add=None, filterinfo=None,
             session=None, elementId=None, sortColumnList=None, firstrecord=None, pagesize=None):
    u'''Функция получения данных для грида. '''
    
    u"""Курсор таблицы с лекциями"""
    lecturesCur = vw_course_cycle_lecturesCursor(context)
    
    u"""Определение переменной для JSON-данных"""
    data = {"records":{"rec":[
                              ]}
            }
 
    u"""Заголовки для столбцов грида"""
    _headers = {'id': ["~~id"],
                'LectureName': [u'Название лекции'],
                "properties": ["properties"]
                }
       
    u"""Приведение названий столбцов к формату поддерживаемому XML файлами"""    
    for column in _headers:
        _headers[column].append(toHexForXml(_headers[column][0]))
        
    main_jsn = json.loads(main)
    cycle_id = main_jsn['cycle_id']
#     certificate = main_jsn['certificate']
                
    lecturesCur.setRange('course_cycle_id', cycle_id)
    lecturesCur.orderBy('lecture_name')
    
    u"""Получения данных из таблицы qtiThemes для отображения их в гриде"""
    for lecture in lecturesCur.iterate():
        lecture_dict = {}
        lecture_dict[_headers['id'][1]] = lecture.qti_package_id
        lecture_dict[_headers['LectureName'][1]] = {"a": {
                                                        "@class": "gwt-Anchor",
                                                        "@href": lecture.lecture_ref,
                                                        "@target": "_blank",
                                                        "#text": lecture.lecture_name}}
#         u'''<a class="gwt-Anchor" href="{0}" target="_blank">{0}</a>'''.format(lecture.lecture_ref, lecture.lecture_name)
        
        
        lecture.lecture_ref
                
        data["records"]["rec"].append(lecture_dict)
        
    lecturesCur.close()
    
    u"""Конвертация JSON-данных в XML"""
    data = XMLJSONConverter.jsonToXml(json.dumps(data))
    
    return JythonDTO(data, None)


def gridMeta(context, main, add=None, filterinfo=None,
             session=None, elementId=None):
    u"""Функция получения параметров для грида"""    
    session = json.loads(session)
    
    u"""Курсор таблицы qtiThemes"""
    lecturesCur = vw_course_cycle_lecturesCursor(context)  
    main_jsn = json.loads(main)
    cycle_id = main_jsn['cycle_id']
#     certificate = main_jsn['certificate']
    lecturesCur.setRange('course_cycle_id', cycle_id)
    u"""Количество записей в таблице"""
    totalcount = lecturesCur.count()
    lecturesCur.close()
    u"""Настройки грида"""
    settings = {}
    settings["gridsettings"] = {'labels': {'header': 'Доступные лекции'},
                                "columns": {"col": []},
                                "properties": {"@gridHeight": getGridHeight(session, 2),
                                               "@gridWidth": '100%',
                                               "@totalCount": totalcount,
                                               "@pagesize": "100"  # Максимальное количество отображаемых записей
                                               }
                                }
    settings["gridsettings"]["columns"]["col"].append({"@id":u'Название лекции'})
 
    return JythonDTO(None, XMLJSONConverter.jsonToXml(json.dumps(settings)))
