# coding:utf-8
'''
Created on 06.08.2014

@author: v.popov
'''

from com.ziclix.python.sql import zxJDBC
from com.ziclix.python.sql import PyConnection
from net.sf.jasperreports.engine.util import JRXmlUtils, JRLoader, JRProperties
from net.sf.jasperreports.engine import JasperFillManager, JasperExportManager, \
    JRParameter
from net.sf.jasperreports.engine.export import JRPdfExporter, JRPdfExporterParameter
from net.sf.jasperreports.engine.data import JRXmlDataSource
from net.sf.jasperreports.engine.query import JRXPathQueryExecuterFactory
from java.io import ByteArrayInputStream, InputStream, OutputStream, ByteArrayOutputStream, \
    FileOutputStream, FileInputStream
from ru.curs.celesta.showcase.utils import XMLJSONConverter
import json
from java.util import ArrayList
from org.xml.sax import InputSource
from java.io import StringReader


def printToPdf(dataXml, jasperFormFileName, resultstream):
    u'''Печатаем один документ из многих источников.
    dataXml - список xml строк с данными,
    jasperFormFileName - название .jasper  файла, подразумевается, что лежит в этой папке,
    resultstream - выходной поток, для печати в файл пишем FileOutputStream("test.pdf"),
    для других случаев соответственно другое.'''

    #Устанавливаем шрифт
    JRProperties.setProperty("net.sf.jasperreports.awt.ignore.missing.font", "true")
    JRProperties.setProperty("net.sf.jasperreports.default.font.name", "Times New Roman Cyr")

    # если данные в видем списка, то оставляем так, если в виде строки - добавляем в список
    if isinstance(dataXml, unicode):
        data = [dataXml]
    elif isinstance(dataXml, list):
        data = dataXml

    # создаем массив поток чтения XML данных из data
    data_streams = [StringReader(elem) for elem in data]

    # Задаем параметры отчета
    jasperparams = {
                    JRXPathQueryExecuterFactory.XML_DATE_PATTERN:"yyyy-MM-dd",
                    JRXPathQueryExecuterFactory.XML_NUMBER_PATTERN:"#,##0.##",
                    }
    # список для отдельных печатных форм
    jprintlist = ArrayList()

    for tds in data_streams:
        # парсим поток и создаем из него DOM документа
        document = JRXmlUtils.parse(InputSource(tds))
        # добавляем в список печатных форм заполненную данными форму
        jprintlist.add(JasperFillManager.fillReport(JRLoader.loadObject(jasperFormFileName),
                                                     jasperparams, JRXmlDataSource(document)))

    # инициализируем экспорте в PDF
    exporter = JRPdfExporter()
    # в список печати устанавливаем наш
    exporter.setParameter(JRPdfExporterParameter.JASPER_PRINT_LIST, jprintlist)
    # выходной потом настраиваем на нам resultstream
    exporter.setParameter(JRPdfExporterParameter.OUTPUT_STREAM, resultstream)
    # экспортируем отчет
    exporter.exportReport()

    # закрываем поток
    #resultstream.close()

def addToJrPrintList(dataXml, jasperFormFileName, jprintlist):
    u'''Добавляем страницу в JrPrintList.'''

    #Устанавливаем шрифт
    JRProperties.setProperty("net.sf.jasperreports.awt.ignore.missing.font", "true")
    JRProperties.setProperty("net.sf.jasperreports.default.font.name", "Times New Roman Cyr")

    # если данные в видем списка, то оставляем так, если в виде строки - добавляем в список
    if isinstance(dataXml, unicode):
        data = [dataXml]
    elif isinstance(dataXml, list):
        data = dataXml

    # создаем массив поток чтения XML данных из data
    data_streams = [StringReader(elem) for elem in data]

    # Задаем параметры отчета
    jasperparams = {
                    JRXPathQueryExecuterFactory.XML_DATE_PATTERN:"yyyy-MM-dd",
                    JRXPathQueryExecuterFactory.XML_NUMBER_PATTERN:"#,##0.##",
                    }
    for tds in data_streams:
        # парсим поток и создаем из него DOM документа
        document = JRXmlUtils.parse(InputSource(tds))
        # добавляем в список печатных форм заполненную данными форму
        jprintlist.add(JasperFillManager.fillReport(JRLoader.loadObject(jasperFormFileName),
                                                     jasperparams, JRXmlDataSource(document)))

def printJrPrintToPdf(jprintlist, resultstream):
    u'''Печатаем jprintlist в PDF. '''

        #Устанавливаем шрифт
    JRProperties.setProperty("net.sf.jasperreports.awt.ignore.missing.font", "true")
    JRProperties.setProperty("net.sf.jasperreports.default.font.name", "Times New Roman Cyr")

    # Задаем параметры отчета
    jasperparams = {
                    JRXPathQueryExecuterFactory.XML_DATE_PATTERN:"yyyy-MM-dd",
                    JRXPathQueryExecuterFactory.XML_NUMBER_PATTERN:"#,##0.##",
                    }
    # инициализируем экспорте в PDF
    exporter = JRPdfExporter()
    # в список печати устанавливаем наш
    exporter.setParameter(JRPdfExporterParameter.JASPER_PRINT_LIST, jprintlist)
    # выходной потом настраиваем на нам resultstream
    exporter.setParameter(JRPdfExporterParameter.OUTPUT_STREAM, resultstream)
    # экспортируем отчет
    exporter.exportReport()

    # закрываем поток
    resultstream.close()

def printOneJR(currentXml, jasperForm, resultstream):
    u'''Печатаем один документ из одного источника. '''
    #Устанавливаем шрифт
    JRProperties.setProperty("net.sf.jasperreports.awt.ignore.missing.font", "true")
    JRProperties.setProperty("net.sf.jasperreports.default.font.name", "Times New Roman Cyr")

    document = JRXmlUtils.parse(ByteArrayInputStream(currentXml.encode("utf-8")))
    #document = JRXmlUtils.parse(currentXml)

    jasperparams = {
                JRXPathQueryExecuterFactory.PARAMETER_XML_DATA_DOCUMENT:document,
                JRXPathQueryExecuterFactory.XML_DATE_PATTERN:"yyyy-MM-dd",
                JRXPathQueryExecuterFactory.XML_NUMBER_PATTERN:"#,##0.##",
                }

    # в jprintOutStream  записываем скомпилированный, готовый к печати jprint
    jprintOutStream = ByteArrayOutputStream()
    JasperFillManager.fillReportToStream(JRLoader.loadObject(jasperForm), jprintOutStream, jasperparams)

    # Конвертируем ByteArrayOutputStream  в ByteArrayInputStream
    jprintInStream = ByteArrayInputStream(jprintOutStream.toByteArray())

    # cоздаем pdf И записываем в resultstream
    JasperExportManager.exportReportToPdfStream(jprintInStream, resultstream)

    # закрываем файловые потоки
    #currentXml.close()
    resultstream.close()

def getOnePdfStream(currentXml, jasperForm):

    #Устанавливаем шрифт
    JRProperties.setProperty("net.sf.jasperreports.awt.ignore.missing.font", "true")
    JRProperties.setProperty("net.sf.jasperreports.default.font.name", "Times New Roman Cyr")

    document = JRXmlUtils.parse(ByteArrayInputStream(currentXml.encode("utf-8")))
    #document = JRXmlUtils.parse(currentXml)

    jasperparams = {
                JRXPathQueryExecuterFactory.PARAMETER_XML_DATA_DOCUMENT:document,
                JRXPathQueryExecuterFactory.XML_DATE_PATTERN:"yyyy-MM-dd",
                JRXPathQueryExecuterFactory.XML_NUMBER_PATTERN:"#,##0.##",
                }

    # в jprintOutStream  записываем скомпилированный, готовый к печати jprint
    jprintOutStream = ByteArrayOutputStream()
    JasperFillManager.fillReportToStream(JRLoader.loadObject(jasperForm), jprintOutStream, jasperparams)

    # Конвертируем ByteArrayOutputStream  в ByteArrayInputStream
    jprintInStream = ByteArrayInputStream(jprintOutStream.toByteArray())
    resultstream = ByteArrayOutputStream()
    # cоздаем pdf И записываем в resultstream
    JasperExportManager.exportReportToPdfStream(jprintInStream, resultstream)

    return resultstream

def concatenatePdf(pdfstreams, resultstream):
    u'''Склеиваем несколько потоков в один и записываем в результат. '''

    import com.itextpdf.text.pdf.PdfReader as PdfReader
    import com.itextpdf.text.pdf.PdfConcatenate as PdfConcatenate

    pdfc = PdfConcatenate(resultstream)
    for stream in pdfstreams:
        pdfis = PdfReader(stream.toByteArray())
        pdfc.addPages(pdfis)

    try:
        pdfc.close()
    except:
        pass
    
    
